Unit Lista_Str_u_H1A;   {Hibs: 21,57}

Interface
   {
     TElem tpus, 2-irny listk kezelse:
   }
   Type
       TElem  = String;

       Mut       = ^TListaElem;
       TListaElem= Record
		             szoveg :TElem;
		             kov,elo:Mut
                   End;
       TLista    = Record
                     fej,akt:Mut;
                     hiba   :Boolean;
                     db     :Integer;
                   End;

   Const     UresLista: TLista=(fej:Nil;akt:Nil; hiba:False; {db:0});
   Procedure Ures{legyen}(Var l:TLista);
   Function  UresE{?}(l:TLista): Boolean;
   Function  Hossz(l:TLista):Integer;
   Procedure Elejere{pozicional}(Var l:TLista);
   Procedure Vegere{pozicional}(Var l:TLista);
   Procedure Beilleszt{mg}(Var l:TLista; Const elem:TElem);
   Procedure BeillesztEle(Var l:TLista; Const elem:TElem);
   Procedure Listabol{kivesz}(Var l:TLista);
   Procedure Kovre{pozicional}(Var l:TLista);
   Procedure Elozore{pozicional}(Var l:TLista);
   Function  Elem(Var l:TLista):TElem;
   Procedure ElemModosit(Var l:TLista; Const e:TElem);
   Function  UtolsoE{?}(Var l:TLista):Boolean;
   Function  ElsoE{?}(Var l:TLista):Boolean;
   Function  HibasE{?}(Var l:TLista):Boolean;
   Function  Masolat(Const l:TLista):TLista;

Implementation

   Procedure Felszabadit(Var mit: Mut);
   Begin
     If mit<>Nil then
     Begin
       Felszabadit(mit^.kov); Dispose(mit); mit:=Nil
     End
   End;

   Procedure Ures(Var l:TLista);
   Begin
     If l.fej<>Nil then Felszabadit(l.fej);
     l.akt:=Nil; l.hiba:=False; l.db:=0;
   End;

   Function UresE{?}(l:TLista):Boolean;
   Begin
     UresE:=(l.fej<Nil)
   End;

   Function  Hossz(l:TLista):Integer;
   Begin
     Hossz:=l.db
   End;

   Procedure Elejere{pozicional}(Var l:TLista);
   Begin
     If l.fej=Nil then l.hiba:=True;
     l.akt:=l.fej
   End;

   Procedure Vegere{pozicional}(Var l:TLista);
   Begin
     If l.fej=Nil then
     Begin
       l.hiba:=True
     End
       else
     Begin
       l.akt:=l.fej;
       While not (l.akt^.kov=Nil) do l.akt:=l.akt^.kov
     End;
   End;

   Procedure Beilleszt{mg}(Var l:TLista; Const elem:TElem);
     Var
        uj : Mut;
   Begin
     New(uj);
     If l.fej=Nil then
     Begin
       uj^.szoveg:=elem; uj^.kov:=Nil; uj^.elo:=Nil;
       l.fej:=uj; l.akt:=l.fej
     End else
     If l.akt=Nil then {lelptnk a listrl: beszrs a vgre}
     Begin
       l.akt:=l.fej;
       While l.akt^.kov^.kov<>Nil do l.akt:=l.akt^.kov;
       uj^.szoveg:=elem; uj^.kov:=l.akt^.kov;
       l.akt^.kov:=uj; l.akt:=uj
     End
         Else
     Begin
       uj^.szoveg:=elem; uj^.kov:=l.akt^.kov; uj^.elo:=l.akt;
       If l.akt^.kov<>Nil then l.akt^.kov^.elo:=uj;
       l.akt^.kov:=uj;
       l.akt:=uj;
     End;
     Inc(l.db)
   End;

   Procedure BeillesztEle(Var l:TLista; Const elem:TElem);
     Var
        uj : Mut;
   Begin
     New(uj);
     If l.fej=Nil then {resbe}
     Begin
       uj^.szoveg:=elem; uj^.kov:=Nil; uj^.elo:=Nil;
       l.fej:=uj; l.akt:=l.fej
     End else
     If l.akt=l.fej then {1. elem}
     Begin
       uj^.szoveg:=elem; uj^.kov:=l.fej; uj^.elo:=Nil;
       l.akt^.elo:=uj;
       l.fej:=uj; l.akt:=l.fej
     End
        Else
     Begin
       uj^.szoveg:=elem; uj^.kov:=l.akt; uj^.elo:=l.akt^.elo;
       {az akt nem az 1.} l.akt^.elo^.kov:=uj;
       l.akt^.elo:=uj;
       l.akt:=uj
     End;
     Inc(l.db)
   End;

   Procedure Listabol{kivesz}(Var l:TLista);
     Var
        ki : Mut;
   Begin
     If (l.fej<>Nil) and (l.akt<>Nil) then
     Begin
       ki:=l.akt;
       l.akt:=l.fej;
       If l.akt=ki then {az 1. elem a kihagyand}
       Begin
         l.fej:=l.fej^.kov; l.akt:=l.fej;
         Dispose(ki); 
       End
          Else
       Begin
         While l.akt^.kov<>ki do l.akt:=l.akt^.kov;
         l.akt^.kov:=ki^.kov;
         Dispose(ki);
       End;
       Dec(l.db);
     End
         Else
       l.hiba:=True;
     {EndIf};
   End;

   Procedure Kovre{pozicional}(Var l:TLista);
   Begin
     If l.akt<>Nil then l.akt:=l.akt^.kov;
     If l.akt=Nil then l.hiba:=True;
   End;

   Procedure Elozore{pozicional}(Var l:TLista);
   Begin
     If l.akt<>Nil then l.akt:=l.akt^.elo;
     If l.akt=Nil then l.hiba:=True;
   End;

   Function Elem(Var l:TLista):TElem;
   Begin
     If l.akt<>Nil then Elem:=l.akt^.szoveg
                   else l.hiba:=True;
   End;

   Procedure ElemModosit(Var l:TLista; Const e:TElem);
   Begin
     If l.akt<>Nil then l.akt^.szoveg:=e
                   else l.hiba:=True;
   End;

   Function  UtolsoE{?}(Var l:TLista):Boolean;
   Begin
     If l.fej=Nil then
     Begin
       l.hiba:=True; 
       UtolsoE:=False; //hogy megengedett legyen a fggvnyrtk
     End
       else
     Begin
       UtolsoE:=(l.akt^.kov=Nil)
     End;
   End;

   Function  ElsoE{?}(Var l:TLista):Boolean;
   Begin
     If l.fej=Nil then 
     Begin
       l.hiba:=True; 
       ElsoE:=False; //hogy megengedett legyen a fggvnyrtk
     End
       else
     Begin
       ElsoE:=(l.akt^.elo=Nil)
     End;
   End;

   Function  HibasE{?}(Var l:TLista):Boolean;
   Begin
     HibasE:=l.hiba; l.hiba:=False;
   End;

   Function  Masolat(Const l:TLista):TLista;
     Var
       ll,ls:TLista;
       i:Integer;
   Begin
     ls:=l; //az l llapota ne vltozzon
     ll:=UresLista; Elejere(ls);
     For i:=1 to Hossz(ls) do
     Begin
       Beilleszt(ll,Elem(ls));
       Kovre(ls);
     End;//a vgn az ls hiba-llapotba kerl, de az nem baj!
     Masolat:=ll;
   End;
   
Begin
  {fej:=Nil; akt:=Nil; hiba:=False}
End.
